{% extends "./plantilla.html" %}
{% load static %}
{% block contenido %}

<div class="row">
    <div class="col-md-5" style="">
        <form action="guardarCarrera/" method="post" enctype="multipart/form-data" id="frm_nueva_carrera">
            <center><h1 class="mt-3 mx-2 text-dark"><strong>CARRERAS SEDP</strong></h1></center>
            {% csrf_token %}
            <br>
            <b>NOMBRE:</b>
            <input type="text" name="nombre_carrera" value="" id="nombre_carrera" placeholder="Ingrese el nombre" class="form-control" required>
            <br>
            <b>DIRECTOR:</b>
            <input type="text" name="director_carrera" value="" id="director_carrera" placeholder="Ingrese el director" class="form-control" required>
            <br>
            <div class="form-group">
                <label for="perfil_egreso"><b>Perfil de egreso:</b></label>
                <select class="form-control" id="perfil_egreso" name="perfil_egreso" required>
                    <option value="">Selecciona el perfil de egreso</option>
                    <option value="Ingeniero">Ingeniero/Ingeniera</option>
                    <option value="Licenciado">Licenciado/Licenciada</option>
                    <option value="Tecnólogo">Tecnólogo/Tecnóloga</option>
                </select>
            </div>

            <div class="form-group">
            <label for="duracion_carrera"><b>NUMERO DE SEMESTRES:</b></label>
            <select class="form-control" id="duracion_carrera" name="duracion_carrera" required>
                <option value="">SELECIONE EL NUMERO SEMESTRES</option>
                <option value="4">4 SEMESTRES</option>
                <option value="5">5 SEMESTRES</option>
                <option value="6">6 SEMESTRES</option>
                <option value="7">7 SEMESTRES</option>
                <option value="8">8 SEMESTRES</option>
                <option value="9">9 SEMESTRES</option>
                <option value="10">10 SEMESTRES</option>
            </select>
          </div>

            <b>LOGO:</b>
            <input type="file" name="logo_carrera" accept="image/*" id="logo_carrera" required>
            <script>
              $(document).ready(function () {
                  $("#logo_carrera").fileinput({
                    //showUpload:false
                    //showRemove: false,
                    language:'es',
                  });
              });
            </script>
            <br>
            <br>
            <center>
                <button type="submit" name="button" class="btn btn-dark">Guardar</button>
                &nbsp;&nbsp;&nbsp;
                &nbsp;&nbsp;&nbsp;
                &nbsp;&nbsp;&nbsp;
                <button type="submit" name="button" class="btn btn-danger">Cancelar</button>
            </center>
        </form>
    </div>
    <div class="col-md-7">
        <div class="d-flex justify-content-center align-items-center">
        </div>
        <br>
        <table class="table table-bordered table-striped" id="tbl_carreras">
            <thead class="table-dark">
                <tr>
                    <th>ID</th>
                    <th>NOMBRE</th>
                    <th>DIRECTOR</th>
                    <th>LOGO</th>
                    <th>PERFIL EGRESO</th>
                    <th>SEMESTRES</th>
                    <th>ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                {% for carrera in carreras %}
                    <tr>
                        <td>{{ carrera.idCarreraSEDP }}</td>
                        <td>{{ carrera.nombreCarreraSEDP }}</td>
                        <td>{{ carrera.directorCarreraSEDP }}</td>

                        <td>{% if carrera.logoCarreraSEDP %}
                            <a href="{{ carrera.logoCarreraSEDP.url }}" target="_blank">
                                <img src="{{ carrera.logoCarreraSEDP.url }}" alt="" height="50px"></a>
                            {% else %}
                            <b>N/A</b>
                            {% endif %}
                        </td>
                        <td>{{ carrera.perfilEgresoCarrera }}</td>
                        <td>{{ carrera.duracionCarrera }}</td>
                        <td>
                            <a href="/editarCarrera/{{ carrera.idCarreraSEDP }}" class="btn btn-warning btn-sm">Editar</a>
                            <a href="javascript:void(0)" onclick="eliminarCarrera('/eliminarCarrera/{{ carrera.idCarreraSEDP }}');" class="btn btn-danger btn-sm">Eliminar</a>
                        </td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
        <div class="d-flex justify-content-center">
                      <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
                  </div>

                  <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
                  <canvas id="myChart"></canvas>
                  </div>

        <!-- Agregar una fila para la imagen debajo de la tabla -->
        <br>
    </div>
</div>

<script type="text/javascript">
    function eliminarCarrera(url) {
        iziToast.question({
            timeout: 15000,
            close: true,
            overlay: true,
            displayMode: 'once',
            id: 'question',
            zindex: 999,
            title: 'CONFIRMACIÓN',
            message: '¿Está seguro de eliminar la carrera seleccionada?',
            position: 'center',
            buttons: [
                ['<button><b>SI</b></button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    window.location.href=url;
                }, true],
                ['<button>NO</button>', function (instance, toast) {
                    instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                }],
            ]
        });
    }
</script>

<script type="text/javascript">
    $("#frm_nueva_carrera").validate({
        rules:{
            "nombre_carrera": {
                required:true
            },
            "director_carrera": {
                required:true
            },
            "perfil_egreso": {
                required:true
            },
            "duracion_carrera": {
                required:true,
                number:true
            },
            "logo_carrera": {
                required:true
            }
        },
        messages:{
            "nombre_carrera": {
                required:"DEBE INGRESAR EL NOMBRE DE LA CARRERA"
            },
            "director_carrera": {
                required:"DEBE INGRESAR EL DIRECTOR DE LA CARRERA"
            },
            "perfil_egreso": {
                required:"DEBE INGRESAR EL PERFIL DE EGRESO DE LA CARRERA"
            },
            "duracion_carrera": {
                required:"DEBE INGRESAR LA DURACIÓN DE LA CARRERA",
                number:"INGRESE SOLO NÚMEROS PARA LA DURACIÓN"
            },
            "logo_carrera": {
                required:"SELECCIONE EL LOGO DE LA CARRERA"
            }
        }
    });
</script>

<script type="text/javascript">
    $('#tbl_carreras').DataTable({
        "language": {
            "url": "https://cdn.datatables.net/plug-ins/1.10.24/i18n/Spanish.json"
        },
        dom: 'Bfrtip',
        buttons: [
            {
                extend: 'pdfHtml5',
                messageTop: 'REPORTE DE CARRERAS - DJANGO Y DATATABLES.'
            },
            'print',
            'csv'
        ]
    });
</script>
<div class="d-flex justify-content-center">
              <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
          </div>

          <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
          <canvas id="myChart"></canvas>
          </div>

          <script>
          document.addEventListener('DOMContentLoaded', function () {
          const ctx = document.getElementById('myChart');

          const tiposSet = new Set();

          const carrerasTipo = {};
          {% for carrera in carreras %}
          tiposSet.add("{{ carrera.duracionCarrera }}");
          if (!carrerasTipo["{{ carrera.duracionCarrera  }}"]) {
                        carrerasTipo["{{ carrera.duracionCarrera }}"] = 1;
                      } else {
                        carrerasTipo["{{ carrera.duracionCarrera }}"] += 1;
                      }

          {% endfor %}
          const tiposArray = Array.from(tiposSet);
          const posiciones = tiposArray.map((tipo, index) => ({ x: index, y: carrerasTipo[tipo] || 0 }));

          new Chart(ctx, {
          type: 'bar',
          data: {
            labels: tiposArray,
            datasets: [{
              label: 'DURACIÓN DE LAS CARRERAS',
              data: posiciones.map(posicion => posicion.y),
              backgroundColor: 'rgba(75, 192, 192, 0.5)',
              borderColor: 'rgba(75, 192, 192, 1)',
              borderWidth: 1,
            }]
          },
          options: {
            scales: {
              x: {
                type: 'category',
                position: 'bottom',
              },
              y: {
                beginAtZero: true,
                max: 10,
                stepSize: 1,
              }
            }
          }
          });
          window.toggleChart = function() {
          const chartContainer = document.getElementById('chartContainer');

          if (chartContainer.style.display === 'none') {
            chartContainer.style.display = 'block';
          } else {
            chartContainer.style.display = 'none';
          }
          };
          });

          </script>

{% endblock %}
